<template>
  <v-select
    :readonly="readonly"
    :label="label"
    :items="years"
    v-model="selectedValue"
    clearable
    outlined
    dense
    :rules="rules"
    @change="$emit('change')"
  />
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator'

@Component({ components: {} })
export default class YearSelect extends Vue {
  @Prop({ required: true }) value!: string
  @Prop({ default: false }) readonly!: boolean
  @Prop({ default: 'Viti' }) label!: string
  @Prop() rules!: string

  years: Array<any> = []
  public get selectedValue() {
    return this.value
  }

  public set selectedValue(newValue: string) {
    this.$emit('input', newValue)
  }
  mounted() {
    this.fetch()
  }
  fetch() {
    let currentYear = new Date().getFullYear()
    const startYear = 1990

    while (startYear <= currentYear) {
      this.years.push(currentYear.toString())
      currentYear--
    }
  }
}
</script>
